<?php
/**
 *
 * @package	    Pay My Bill Module
 * @subpackage	Pay My Bill Module
 * @version     1.0.0
 * @description Pay My Bill Module
 * @copyright	  Copyright © 2013 - All rights reserved.
 * @license		  GNU General Public License v2.0
 * @author		  SoftPill.Eu
 * @author mail	mail@softpill.eu
 * @website		  www.softpill.eu
 *
 */
//ini_set("display_errors",0);
//error_reporting(E_ALL);
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
class PMBpayuhungary
{
  function checkMethod($params)
  {
    $vendor_missing=JText::_( 'PMB_PAYUHUNGARY_MODULE_ERR_VENDOR' );
    $password_missing=JText::_( 'PMB_PAYUHUNGARY_MODULE_ERR_PASS' );
    $vendor_name=trim($params->get('payuhungary_user'));
    $vendor_password=trim($params->get('payuhungary_password'));
    
    if($vendor_name=='')
    {
      ?>
        <div class="pmb_error"><?php echo $vendor_missing;?></div>
      <?php
      return false;
    }
    else if($vendor_password=='')
    {
      ?>
        <div class="pmb_error"><?php echo $password_missing;?></div>
      <?php
      return false;
    }

    return true;
  }
  function getPMBDomain()
  {
    $domain=str_ireplace("www.","",$_SERVER['HTTP_HOST']);
    $is_ip = ip2long($domain) !== false;
    if($is_ip)
    {
      return false;
    }
    else if(trim($domain)=='')
    {
      return false;
    }
    
    return $domain;
  }
  function doPayment($params,$details,$all_params)
  {
    /**/
    $dchk=$all_params['dchk'];
    $lic=$all_params['pmblic'];
    $the_domain=$this->getPMBDomain();
    if($the_domain)
    {
      $chk=md5($lic.$the_domain);
      if($dchk!=$chk)
      {
        echo '<font color="red"><strong>'.JText::_( 'PMB_MODULE_LICENSE_ERR' ).'</strong></font>';
        exit;
      }
    }
    
    $product_name=$params->get('product_name');
    $invoice_field=$params->get('show_inv_field');
    $cost_per_transaction=$params->get('payuhungary_trans_cost')+0;
    $percent_per_transaction=$params->get('payuhungary_trans_percent_cost')+0;
    
    $vendor_name=trim($params->get('payuhungary_user'));
    $vendor_password=trim($params->get('payuhungary_password'));
    $language=$params->get('payuhungary_language');
    
    $currency=$params->get('payuhungary_currency');
    
    $details['subtotal']=$details['payment'];
    $payment=$details['payment'];
    if($cost_per_transaction>0)
    {
      $payment+=$cost_per_transaction;
    }
    if($percent_per_transaction>0)
    {
      $payment=$payment+($payment*$percent_per_transaction);
    }
    
    $payment=round($payment,2);
    $payment=number_format($payment,2);
    $details['payment']=$payment;
    $details['mode']='N/A';
    $details['currency']=$currency;
    if($params->get('mail_pending')!=0)
    {
      require_once(JPATH_BASE.DS."modules".DS."mod_paymybill".DS."functions".DS."functions.php");
      $pmbf=new PMBFunctions();
      $pmbf->sendConfirmationMail("pending",$all_params,$details,'PayuHungary');//send pending mail
    }
    $pmbf->saveOrder($payment,$mode,$all_params,$details,'PayuHungary');
    $PaymentDescription=$product_name.' at '.$_SERVER['HTTP_HOST'].' order.';
    
    if($invoice_field)
    {
      $PaymentDescription=$product_name.' at '.$_SERVER['HTTP_HOST'].' for '.$details['InvNr'];
    }
    
    $return_url=JROUTE::_(JURI::root()."modules/mod_paymybill/return/payuhungary_return.php");
    $cancel_url=JROUTE::_(JURI::root()."modules/mod_paymybill/return/payuhungary_cancel.php");
    
    $config = array(
    	'MERCHANT' => $vendor_name,																		//merchant account ID
    	'SECRET_KEY' => $vendor_password,																		//secret key for account ID	
    	'METHOD' => "",																			//payment method	 empty -> select payment method on PayU payment page OR [ CCVISAMC, WIRE, CASH, PAYU_MOBILE ]
    	'ORDER_DATE' => date("Y-m-d H:i:s"),													//date of transaction
    	'LOGGER' => false,																		//transaction log
    	'LOG_PATH' => 'log',																	//path of log file
    	'BACK_REF' => $return_url,						//url of payu payment backref page
    	'TIMEOUT_URL' => $cancel_url,					//url of payu payment timeout page
    	'ORDER_TIMEOUT' => 900,
    	'LANGUAGE' => $language
    );
    
    $currency_code_arr=array('HUF','EUR','USD');
    if(!in_array($currency,$currency_code_arr))
    {
      $currency='HUF';
    }
    
    $myOrderRef	= $details['order_id'];
    $lu = new PayUHungaryLiveUpdatePMB($config);
    $lu->setField("ORDER_DATE", $config['ORDER_DATE']);
  	$lu->setField("BACK_REF", $config['BACK_REF']);
  	$lu->setField("TIMEOUT_URL", $config['TIMEOUT_URL']);
  	$lu->setField("ORDER_TIMEOUT", $config['ORDER_TIMEOUT']);
    $lu->setField("PAY_METHOD", '');
		$lu->setField("AUTOMODE", 0);
    $lu->setField("ORDER_REF", $myOrderRef);
  	$lu->setField("PRICES_CURRENCY", $currency);
  	$lu->setField("ORDER_SHIPPING", 0); 
  	$lu->setField("LANGUAGE", $config['LANGUAGE']);
  	$lu->setField("ORDER_PRICE_TYPE", "GROSS");
    
    $lu->addProduct(array(
    		'name' => $PaymentDescription,								//product name [ string ]
    		'code' => $details['order_id'],							//merchant systemwide unique product ID [ string ]
    		'info' => '',				//product description [ string ]
    		'price' => $payment, 								//product price [ HUF: integer | EUR, USD decimal 0.00 ]
    		'vat' => 0,										//product tax rate [ in case of gross price: 0 ] (percent)
    		'qty' => 1									//product quantity [ integer ] 
    	));
    
    $lu->setField("BILL_FNAME", $details['BillFname']);
  	$lu->setField("BILL_LNAME", $details['BillLname']);
  	$lu->setField("BILL_EMAIL", $details['BillEmail']); 
  	$lu->setField("BILL_PHONE", $details['BillPhone']);
  	$lu->setField("BILL_COUNTRYCODE", $details['BillCountry']);
  	$lu->setField("BILL_STATE", $details['BillState']);
  	$lu->setField("BILL_CITY", $details['BillCity']); 
  	$lu->setField("BILL_ADDRESS", $details['BillAddr']); 
  	$lu->setField("BILL_ADDRESS2", '');
  	$lu->setField("BILL_ZIPCODE", $details['BillZip']);
    
    $lu->setField("DELIVERY_FNAME", $details['BillFname']); 
    $lu->setField("DELIVERY_LNAME", $details['BillLname']); 
    $lu->setField("DELIVERY_EMAIL", $details['BillEmail']); 
    $lu->setField("DELIVERY_PHONE", $details['BillPhone']); 
    $lu->setField("DELIVERY_COUNTRYCODE", $details['BillCountry']);
    $lu->setField("DELIVERY_STATE", $details['BillState']);
    $lu->setField("DELIVERY_CITY", $details['BillCity']);
    $lu->setField("DELIVERY_ADDRESS", $details['BillAddr']); 
    $lu->setField("DELIVERY_ADDRESS2", '');
    $lu->setField("DELIVERY_ZIPCODE", $details['BillZip']);
    
		$lu->logger = $config['LOGGER'];
	  $lu->log_path = $config['LOG_PATH'];
    
    $PayU_button='Click here to Pay';
    $html = $lu->createHtmlForm('PayUForm', 'auto', $PayU_button);	// format: link, button, auto (auto is redirects to payment page immediately )
    
    ob_end_clean();
    
    echo $html;exit;
  }
}

class PayUHungaryBasePMB {
    protected $merchantId;
    protected $secretKey;
    protected $settingsFile;
    public $debug;
    public $targetUrl;
	public $baseUrl;
    public $logger = false;
    public $log_path = "log";
    protected $hashData = array();
    protected $validFields = array();
    protected $products = array();
    protected $missing = array();
    public $formData = array();
    public $hashFields = array();
    public $fieldData = array();
    
    public $settings = array(
        'MERCHANT' => 'merchantId',
        'SECRET_KEY' => 'secretKey',
        'BASE_URL' => 'baseUrl',
        'ALU_URL' => 'aluUrl',
        'LU_URL' => 'luUrl',
        'IOS_URL' => 'iosUrl',
        'IDN_URL' => 'idnUrl',
        'IRN_URL' => 'irnUrl',
		'OC_URL' => 'ocUrl',
    );
    
    /*
     * Constructor of Base class
     * Cannot be instantiated
     * 
     * @param mixed $config Configuration array or filename
     * @param boolean $debug Debug mode
     */
    protected function __construct($config, $debug=false){
        $this->debug = $debug;

		$defaults = $this->defaultsData();
		$this->processConfig($defaults);
        
        if(is_array($config)){
            $this->processConfig($config);
        } elseif(is_string($config)){
            if(file_exists($config)){
                require_once($config);
                $this->processConfig($config);
            }
        } else {
            echo "Unable to read settings!";
            exit();
        }
    }
 
    /*
     * Set default URL
     * 
     */ 
	public function defaultsData() {
		$defaults = array(
			'BASE_URL' => "https://secure.payu.hu/", //please add TRAILING SLASH
			'LU_URL' => "order/lu.php",   //relative to BASE_URL
			'ALU_URL' => "order/alu.php", //relative to BASE_URL
			'IDN_URL' => "order/idn.php", //relative to BASE_URL
			'IRN_URL' => "order/irn.php", //relative to BASE_URL
			'IOS_URL' => "order/ios.php", //relative to BASE_URL
			'OC_URL' => "order/tokens/"   //relative to BASE_URL
		);
		
		return $defaults;
	}
	
    /*
     * Set config options
     * 
     * @param array $config Array with config options
     */
    public function processConfig($config){
        foreach($config as $setting=>$value){
            if(array_key_exists($setting, $this->settings)){
                $prop = $this->settings[$setting];
                $this->$prop = $config[$setting];
            }
        }
    }
    
    /*
     * HMAC HASH creation
     * RFC 2104
     * http://www.ietf.org/rfc/rfc2104.txt
     * 
     * @param string $key Secret key for encryption
     * @param string $data String to encode
     */
    protected function hmac($key, $data) {
        $b = 64; // byte length for md5
        if (strlen($key) > $b) {
            $key = pack("H*", md5($key));
        }
        $key = str_pad($key, $b, chr(0x00));
        $ipad = str_pad('', $b, chr(0x36));
        $opad = str_pad('', $b, chr(0x5c));
        $k_ipad = $key ^ $ipad;
        $k_opad = $key ^ $opad;
        return md5($k_opad . pack("H*", md5($k_ipad . $data)));exit;
    }

    /*
     * Creates the strings HASH-ready form
     * 
     * @param string $str String to be modified
     */
    protected function stringWithLength($str){
        $str = strlen(StripSlashes($str)).$str;
        return $str;
    }
    
    /*
     * Create HASH code for an array (1-dimension only)
     * 
     * @param array $hashData Array of ordered fields to be HASH-ed
     */
    protected function createHashString($hashData){

        $hashString = "";
        foreach ($hashData as $field){
            if(is_array($field)){
                echo "No multi-dimension array allowed!";
                exit();
            }
            $hashString .= self::stringWithLength($field);
        }
		
		$hashCode = $this->hmac($this->secretKey, $hashString);

        if($this->debug){
            print_r($this->hashFields);
            print_r($hashData);
            echo "\n\nHASH String: <b>".$hashString."\n\n</b>";
			echo "\n\nHASH Code: <b>".$hashCode."\n\n</b>";
        }
        
        return $hashCode;
    }
    
    /*
     * Creates hidden HTML field
     * 
     * @param string $name Name of the field. ID parameter will be generated without "[]"
     * @param sting $value Value of the field 
     */
    public function createHiddenField($name, $value){
        if(substr($name, -2, 2) == "[]"){
           $id = substr($name, 0, -2);
        } else {
            $id = $name;
        }
        //$value = addslashes($value);	
	
		if($name == "BACK_REF" or $name == "TIMEOUT_URL"){
			if (strpos($value, '?') !== FALSE) {
				$concat = '&';
			} else {
				$concat = '?';
			}		
			$value .= $concat.'order_ref='.$this->fieldData['ORDER_REF'];
		}
	
        return "\n<input type='hidden' name='$name' id='$id' value='$value' />";
    }
    
    /*
     * Generates a ready-to-insert HTML FORM
     * 
     * @param string $formName The ID parameter of the form
     * @param array $formData Array of data to be added as hidden fields to the form
     * @param string $submitElement The type of the submit element ('button' or 'link')
     * @param string $submitElementText The lebel for the submit element
     * @param boolean $tags Display open/close TAGs
     */
    public function createHtmlForm($formName, $submitElement=false, $submitElementText=false, $formData=array(), $tags = true, $iframe = true){
        $form = "";
        if($tags){
			
			if (isset($formData['METHOD'])) {
				$formMethod = 'GET';
			} 
			else {
				$formMethod = 'POST';
			}
			
			$form .= "\n\n\n<form action='".$this->baseUrl.$this->targetUrl."' method='".$formMethod."' id='$formName'>";
				
        }
      
		$logString = "";
	   
        foreach ($formData as $name => $field){
		
            if(is_array($field)){
                foreach ($field as $subField){
                    $form .= $this->createHiddenField($name."[]",$subField);
					$logString .= $name.'='.$subField."\n";
                }
            } else {
                $form .= $this->createHiddenField($name,$field);
				$logString .= $name.'='.$field."\n";
            }
        }

		$form .= $this->createHiddenField("SDK_VERSION",$this->sdkVersion());
		$order_id = isset($formData['ORDER_REF']) ? $formData['ORDER_REF'] : 0;
        		
        if($submitElement && $submitElementText){
            if($submitElement == "link"){
                $form .= "\n<a href='javascript:document.getElementById(\"$formName\").submit()'>".addslashes($submitElementText)."</a>";
            } elseif ($submitElement == "button"){
                $form .= "\n<button type='submit'>".addslashes($submitElementText)."</button>";
            } elseif ($submitElement == "auto"){
                $form .= "\n<button type='submit'>".addslashes($submitElementText)."</button>";
				$form .= "\n<script language=\"javascript\" type=\"text/javascript\">document.getElementById(\"$formName\").submit();</script>";	
            }
        }
        if($tags){
            $form .= "\n</form>";
			
        }
        
        return $form;
    }

    /*
     * Generates raw data array with HMAC HASH code for custom processing
     * 
     * @param string $hashFieldName Index-name of the generated HASH field in the associative array
     */
    public function createPostArray($hashFieldName = "ORDER_HASH"){
        if(!$this->prepareFields($hashFieldName)){
            return false;
        }
        
        return $this->formData;
    }
    
    /*
     * Sends a HTTP request via cURL or file_get_contents() and returns the response
     *
     * @param string $url Base URL for request
     * @param array $getParams Parameters to send
     */
    protected function createSimpleRequest($url,$getParams=array()){
        if($this->checkCurl()){
            $response = $this->requestCurl($url,"POST",$getParams);
        } else {
            $response = $this->requestSafe($url."?".http_build_query($getParams), "POST");
        }
        
        return $response;
    }
    
    /*
     * Sends a HTTP request via file_get_contents() and returns the response
     * 
     * @param string $url Base URL for request
     * @param string $method Method to use when sending request (ie: GET, POST)
     */
    private function requestSafe($url, $method="GET"){
        $url = $this->baseUrl.$url;
        $aContext = array(
            'http' => array(
                //'proxy' => 'proxy:8080',
                'method' => $method,
                'request_fulluri' => true,
            ),
        );
        $cxContext = stream_context_create($aContext);

        return file_get_contents($url, False, $cxContext);
    }
    
    /*
     * Sends a HTTP request via cURL and returns the response 
     * 
     * @param string $url Base URL for request
     * @param string $method Method to use when sending request (ie: GET, POST)
     * $param array $params Array of data to send
     */
    protected function requestCurl($url, $method = "GET", $params = null){
        $ch = curl_init();
        $url = $this->baseUrl.$url;
        curl_setopt($ch, CURLOPT_URL, $url);
        
        if($method == "POST"){
            curl_setopt($ch, CURLOPT_POST, true);
        } else {
            curl_setopt($ch, CURLOPT_POST, false);
        }
        
        curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($params));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_USERAGENT, 'curl');
        curl_setopt($ch, CURLOPT_TIMEOUT, 60);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
        $result = curl_exec($ch);
        curl_close($ch);

        return $result;
    }
    
    /*
     * Creates a 1-dimension array from a 2-dimension one
     * 
     * @param array $array Array to be processed
     * @param array $skip Array of keys to be skipped when creating the new array
     */
    protected function flatArray($array, $skip = array()){
        $return = array();
        foreach ($array as $name=>$item){
            if(!in_array($name,$skip)){
                if(is_array($item)){
                    foreach ($item as $subItem){
                        $return[] = $subItem;
                    }
                } else {
                    $return[] = $item;
                }
            }
        }
        return $return;
    }
    
    /*
     * Sets default value for a field
     * 
     * @param array $sets Array of fields and its parameters
     */
    protected function setDefaults($sets){
        foreach($sets as $set){
            foreach ($set as $field=>$fieldParams){
                if($fieldParams['type'] == 'single' && isset($fieldParams['default'])){
                    $this->fieldData[$field] = $fieldParams['default'];
                }
            }
        }
    }
    
    /*
     * Checks if all required fields are set.
     * Returns true or array of missing fields list
     */
    protected function checkRequired(){
        $missing = array();
        foreach ($this->validFields as $field=>$params){
            if(isset($params['required']) && $params['required']){
                if($params['type'] == "single"){
                    if(!isset($this->formData[$field])){
                        $missing[] = $field;
                    }
                } else if($params['type'] == "product"){
                    foreach ($this->products as $prod){
                        $paramName = $params['paramName'];
                        if(!isset($prod->$paramName)){
                            $missing[] = $field;
                        }
                    }
                }
            }
        }

        if($missing != array()){
              return $missing;
        }

        return true;
    }
    
    /*
     * Getter method for fields
     * 
     * @param string $fieldName Name of the field
     */
    public function getField($fieldName){
        return $this->fieldData[$fieldName];
    }
    
    /*
     * Setter method for fields
     * 
     * @param string $fieldName Name of the field to be set
     * @param string $fieldValue Value of the field to be set
     */
    public function setField($fieldName, $fieldValue){
        if(in_array($fieldName, array_keys($this->validFields))){
			
            $this->fieldData[$fieldName] = $fieldValue;
            return true;
        } else {
            return false;
        }
    }
    
    /*
     * Adds product to the $this->product array
     * 
     * @param mixed $product Array description of product or Product object
     */
    public function addProduct($product){
	
        if(is_array($product)){
            $product = new PayUHungaryProductPMB($product);
        } elseif (is_object($product)){
            //@todo istypeof  PayUProduct
      
        }else{
			echo "Not a valid product!";
            exit();
		}
		$this->products[] = $product;
        
    }
    
    /*
     * Finalizes and prepares fields for sending
     * 
     * @param string $hashName Name of the field containing HMAC HASH code
     */
    protected function prepareFields($hashName){
        $this->hashData = array();
        foreach ($this->hashFields as $field){
            $params = $this->validFields[$field];
            if($params['type'] == "single"){
                if(isset($this->fieldData[$field])){
                    $this->hashData[] = $this->fieldData[$field];
                }
            } elseif ($params['type'] == "product"){
                foreach($this->products as $product){
                    if(isset($product->$params["paramName"])){
                        $this->hashData[] = $product->$params["paramName"];
                    }
                }
            }
        }
        
        foreach($this->validFields as $field=>$params){
            if(isset($params["rename"])){
                $field = $params["rename"];
            }
            if($params['type'] == "single"){
                if(isset($this->fieldData[$field])){
                    $this->formData[$field] = $this->fieldData[$field];
                }
            } elseif($params['type'] == "product"){
                if(!isset($this->formData[$field])){
                    $this->formData[$field] = array();
                }
                foreach($this->products as $num=>$product){
                    if(isset($product->$params["paramName"])){
                        $this->formData[$field][$num] = $product->$params["paramName"];
                    }
                }   
            }
        }
        
        if($this->hashData && $hashName){
            $this->formData[$hashName] = $this->createHashString($this->hashData);
        }
        
        $this->missing = $this->checkRequired();
        if($this->missing === true){
            return true;
        } else {
            if ($this->debug) {
                echo "REQUIRED FIELDS MISSING\n";
                echo "More info with getMissing()\n";
            }

            return false;
        }
    }
    
    /*
     * Finds and processes validation response from HTTP response
     * 
     * @param string $resp HTTP response
     */
    public function processResponse($resp){
        preg_match_all("/<EPAYMENT>(.*?)<\/EPAYMENT>/", $resp, $matches);
        $data = explode("|",$matches[1][0]);
        return $this->nameData($data);
    }
    
    /*
     * Validates HASH code of the response
     * 
     * @param array $resp Array with the response data
     */
    public function checkResponseHash($resp){
        $hash = $resp['ORDER_HASH'];
        array_pop($resp);
        $calculated = $this->createHashString($resp);
        if($this->debug){
            echo "\ncalc:".$calculated;
            echo "\nrec: ".$hash."\n";
        }
        if($hash == $calculated){
            return true;
        }
        return false;
    }
    
    /*
     * Check if the cURL PHP extension is available
     */
    protected function checkCurl(){
        if(in_array("curl",  get_loaded_extensions())){
            return true;
        } else {
            return false;
        }
    }
    
    /*
     * Check if the DOM PHP extension is available
     */
    protected function checkDom(){
        if(in_array("dom",  get_loaded_extensions())){
            return true;
        } else {
            return false;
        }
    }
    
    /*
     * Check if the XmlLib PHP extension is available
     */
    protected function checkXmlLib(){
        if(in_array("libxml",  get_loaded_extensions())){
            return true;
        } else {
            return false;
        }
    }
	
    /*
     * Write log
     * 
     * @param string $state State of the payment process
     * @param array $data Data of the log
	 * @param string $order_id External ID of order
     */	  
	public function logFunc($state = '', $data = array(), $order_id = 0) {
		if ($this->logger) {
			$date = date('Y-m-d H:i:s',time());
			$logtext = "";
			foreach($data as $logkey=>$logvalue){
			
				if(is_array($logvalue)) {
					foreach($logvalue as $subkey => $subvalue) {
						$logtext .= $order_id.' '.$state.' '.$date.' '.$logkey.'='.$subvalue."\n";
					}
				} else {
					$logtext .= $order_id.' '.$state.' '.$date.' '.$logkey.'='.$logvalue."\n";
				}
				
			}			
			file_put_contents($this->log_path.'/'.date('Ymd',time()).'.log', $logtext, FILE_APPEND | LOCK_EX); 
		}
	}

    /*
     * Version of SDK
     */
    public function sdkVersion(){
		$version = 'PHP_2.1_sdk20140212';
        return $version;
    }
		
}

class PayUHungaryLiveUpdatePMB extends PayUHungaryBasePMB{
    /*
     * Constructor of PayULiveUpdate class
     * 
     * @param mixed $config Configuration array or filename
     * @param boolean $debug Debug mode
     */
    public function __construct($config, $debug = false){
        $this->hashData = array();
        $this->formData = array();
        $this->logger = false;

        $this->validFields = array(
			//order
            "MERCHANT" => array("type" => "single", "paramName" => "merchantId", "required" => true),
            "ORDER_REF" => array("type" => "single", "required" => true),
            "ORDER_DATE" => array("type" => "single", "required" => true),
            "ORDER_PNAME" => array("type" => "product", "paramName" => "name", "required" => true),
            "ORDER_PCODE" => array("type" => "product", "paramName" => "code", "required" => true),
            "ORDER_PINFO" => array("type" => "product", "paramName" => "info"),
            "ORDER_PRICE" => array("type" => "product", "paramName" => "price", "required" => true),
            "ORDER_QTY" => array("type" => "product", "paramName" => "qty", "required" => true),
            "ORDER_VAT" => array("type" => "product", "default" => "0", "paramName" => "vat", "required" => true),         
            "PRICES_CURRENCY" => array("type" => "single", "default" => "HUF","required" => true),
            "ORDER_SHIPPING" => array("type" => "single", "default" => "0"),           
            "DISCOUNT" => array("type" => "single", "default" => "0"),            
            "PAY_METHOD" => array("type" => "single", "default" => ""),
            "LANGUAGE" => array("type" => "single", "default" => "HU"),            
            "AUTOMODE" => array("type" => "single", "default" => "1"),  
            "ORDER_TIMEOUT" => array("type" => "single"),
            "TIMEOUT_URL" => array("type" => "single"),
            "BACK_REF" => array("type" => "single"),
            "LU_ENABLE_TOKEN" => array("type" => "single", "required" => false),
            "LU_TOKEN_TYPE" => array("type" => "single", "required" => false),
            
			//billing
            "BILL_FNAME" => array("type" => "single", "required" => true),
            "BILL_LNAME" => array("type" => "single", "required" => true),
            "BILL_COMPANY" => array("type" => "single"),
            "BILL_FISCALCODE" => array("type" => "single"),
            "BILL_EMAIL" => array("type" => "single", "required" => true),
            "BILL_PHONE" => array("type" => "single", "required" => true),
            "BILL_FAX" => array("type" => "single"),
            "BILL_ADDRESS" => array("type" => "single", "required" => true),
            "BILL_ADDRESS2" => array("type" => "single"),
            "BILL_ZIPCODE" => array("type" => "single", "required" => true),
            "BILL_CITY" => array("type" => "single", "required" => true),
            "BILL_STATE" => array("type" => "single", "required" => true),
            "BILL_COUNTRYCODE" => array("type" => "single", "required" => true),
            
			//delivery
            "DELIVERY_FNAME" => array("type" => "single", "required" => true),
            "DELIVERY_LNAME" => array("type" => "single", "required" => true),
            "DELIVERY_COMPANY" => array("type" => "single"),
            "DELIVERY_PHONE" => array("type" => "single", "required" => true),
            "DELIVERY_ADDRESS" => array("type" => "single", "required" => true),
            "DELIVERY_ADDRESS2" => array("type" => "single"),
            "DELIVERY_ZIPCODE" => array("type" => "single", "required" => true),
            "DELIVERY_CITY" => array("type" => "single", "required" => true),
            "DELIVERY_STATE" => array("type" => "single", "required" => true),
            "DELIVERY_COUNTRYCODE" => array("type" => "single", "required" => true),
        );
        
		//hash fields
        $this->hashFields = array(
            "MERCHANT",
            "ORDER_REF",
            "ORDER_DATE",
            "ORDER_PNAME",
            "ORDER_PCODE",
            "ORDER_PINFO",
            "ORDER_PRICE",
            "ORDER_QTY",
            "ORDER_VAT",
            "ORDER_SHIPPING",
            "PRICES_CURRENCY",
            "DISCOUNT",
            "PAY_METHOD"
        );

        $this->setDefaults(array(
            $this->validFields
        ));

        parent::__construct($config, $debug);
        $this->fieldData['MERCHANT'] = $this->merchantId;
        $this->targetUrl = $this->luUrl;
		
    }

    /*
     * Generates a ready-to-insert HTML FORM
     * 
     * @param string $formName The ID parameter of the form
     * @param string $submitElement The type of the submit element ('button' or 'link')
     * @param string $submitElementText The lebel for the submit element
     * @param boolean $tags Display open/close TAGs
     */
    public function createHtmlForm($formName, $submitElement=false, $submitElementText=false, $data = array(), $tags=true, $iframe= false){
        if(!$this->prepareFields("ORDER_HASH")){
            return false;
        }
		$this->logFunc("LiveUpdate",$this->formData, $this->formData['ORDER_REF']);
        return parent::createHtmlForm($formName, $submitElement, $submitElementText, $this->formData, $tags, $iframe = false);
    }
    
    /*
     * Sends notification via cURL
     * 
     * @param array $data (Optional) Data array to be sent
     */
    public function requestCurl($data = false, $target = '', $method = ''){
        if(!$data){
            if (!$this->prepareFields("ORDER_HASH")) {
                return false;
            }
            $data = $this->formData;
        }
        return parent::requestCurl($this->targetUrl, "POST", $this->formData);
    }      
    
    /*
     * Returns a list of missing required fields
     * 
     */
    public function getMissing(){
        return $this->missing;
    }
	
	public function log(){
		return $this->log();
	}
}


/**
 * PayU BACK_REF
 * 
 * Processes information sent via HTTP GET on the returning site after a payment
 *
 */
class PayUHungaryBackRefPMB extends PayUHungaryBasePMB{
    
    private $backref;
    private $request;
    private $error;
    private $returnVars = array("RC", "RT", "3dsecure", "date", "payrefno", "ctrl");
	public $backStatusArray = array();
	public $successful_status = array(
		"IN_PROGRESS",			//card authorized on backref
		"PAYMENT_AUTHORIZED",	//IPN
		"COMPLETE",				//IDN
		"WAITING_PAYMENT",		//waiting for WIRE or CASH
		"CASH"					//payed on delivery
	);
	public 	$unsuccessful_status = array(
		"CARD_NOTAUTHORIZED",	//card NOT authorized on backref
		"FRAUD"
	);

	
    /*
     * Constructor of PayUBackRef class
     * 
     * @param mixed $config Configuration array or filename
     * @param string $backref BACK_REF URL sent
     * @param boolean $debug Debug mode
     */
    public function __construct($config, $backref=false, $debug=false){
        parent::__construct($config, $debug);
        $this->backref = $backref;
        
        if($backref){
            $this->createRequestUriGiven();
        } else {
            $this->createRequestUriNotGiven();
        }
	
    }
    
    /*
     * Creates request URI from the given BACK_REF
     * Useful when using special URLs (ie.: https://something.com:4848/)
     * 
     */
    private function createRequestUriGiven(){
	    $this->request = $this->backref;
        if (count($_GET) > 6) {
            $this->request .= "&";
        } else {
            $this->request .= "?";
        }
        foreach ($this->returnVars as $var) {
            $this->request .= $var . "=" . urlencode($_GET[$var]) . "&";
        }
        $this->request = substr($this->request, 0, -1);
    }
    
    /*
     * Creates request URI from HTTP SERVER VARS.
     * Handles http and https
     * 
     */
    private function createRequestUriNotGiven(){
        if (isset($_SERVER['HTTP_FRONT_END_HTTPS']) and $_SERVER['HTTP_FRONT_END_HTTPS'] == "On") {
            $this->request = "https://";
        } else {
            $this->request = "http://";
        }

        $this->request .= $_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
    }
    
    /*
     * Validates CTRL variable
     * 
     */
    private function checkCtrl(){

        $requestURL = substr($this->request, 0, -38); //the last 38 characters are the CTRL param
        $hashInput = strlen($requestURL).$requestURL;
	
		//optional debug info, no need for live payment
		/*if(!$this->debug){
			echo "\n<br />".$this->request;
			echo "\n<br />".$requestURL;
			echo "\n<br />".$this->hmac($this->secretKey, $hashInput);
			echo "\n<br />".$_GET['ctrl'];
		}*/
		
        if ($_GET['ctrl'] == $this->hmac($this->secretKey, $hashInput)) {
            return true;
        } else {
            return false;
        }
    }
    
    /*
     * Check card authorization response
	 *
	 * 1. check ctrl
     * 2. check RC & RT 
	 * 3. check IOS status
     * 
     */
    public function checkResponse(){

		parent::logFunc("BackRef",$_REQUEST,$this->order_ref);
	
        if(!$this->checkCtrl()){
            $this->error = "INVALID CTRL";
            return false;
        }

		if (!isset($this->order_ref)) {
			$this->error = "Missing orfer_ref variable";
			return false;
		}
		
		// Start IOS in the background to confirm "checkResponse"	
		$ios = new PayUHungaryIosPMB(array('MERCHANT' => $this->merchantId, 'SECRET_KEY' => $this->secretKey), $this->order_ref);

		$this->backStatusArray = array(
			'BACKREF_DATE' => $_REQUEST['date'],
			'REFNOEXT' => (is_object($ios)) ? $this->order_ref : 'N/A' ,
			'PAYREFNO' => (is_object($ios)) ? $ios->status['REFNO'] : 'N/A',
			'ORDER_STATUS' => (is_object($ios)) ? $ios->status['ORDER_STATUS'] : 'IOS_ERROR',
			'PAYMETHOD' => (is_object($ios)) ? $ios->status['PAYMETHOD'] : 'N/A'
		);  	
	
		parent::logFunc("BackStatus",$this->backStatusArray,$this->order_ref);
		
		//check IOS ORDER_STATUS
		if (is_object($ios)) {
			if (in_array(trim($ios->status['ORDER_STATUS']),$this->successful_status)) {
				$this->backStatusArray['RESULT'] = true;
				return true;
			} elseif (in_array(trim($ios->status['ORDER_STATUS']),$this->unsuccessful_status)) {
				$this->backStatusArray['RESULT'] = false;
				return false;
			} else {	
				$this->backStatusArray['RESULT'] = false;
				return false;
			}
		} else {
			$this->backStatusArray['RESULT'] = false;
			return false;		
		}		

		//ordinary browser
		if (isset($_GET['RT'])) {
			
			//000 and 001 is successful, unsuccessful otherwise
			if(in_array(substr($_GET['RT'], 0, 3),array("000","001"))) {
				$this->backStatusArray['RESULT'] = true;
				return true; 
			
			//empty return data	
			} elseif ($_GET['RT'] ==""){
				
				//check IOS ORDER_STATUS
				if (in_array(trim($ios->status['ORDER_STATUS']),$this->successful_status)) {
					$this->backStatusArray['RESULT'] = true;
					return true;
				} elseif (in_array(trim($ios->status['ORDER_STATUS']),$this->unsuccessful_status)) {
					$this->backStatusArray['RESULT'] = false;
					return false;
				} else {	
					$this->backStatusArray['RESULT'] = false;
					return false;
				}		
				
			} elseif ($_GET['RT'] =="No Response" || $_GET['RC']=="NR"){
				$this->backStatusArray['RESULT'] = true;
				return true;
			} else {
				$this->backStatusArray['RESULT'] = false;
				return false;
			}
			
		}else {
		
			$this->error = "MISSING VARIABLES";
			$this->backStatusArray['RESULT'] = false;
			return false;	
			
		}

	}
    
    /*
     * Get PayU reference number after chaeckResponse()
     * 
     */
    public function getPayURefNo(){
        return $_GET['payrefno'];
    }

    /*
     * Returns a list of errors if there was any
     * 
     */
    public function getError(){
        return $this->error;
    }
}


/**
 * PayU Instant Payment Notification
 *
 * Processes notifications sent via HTTP POST request
 * 
 */
class PayUHungaryIpnPMB extends PayUHungaryBasePMB{
    /*
     * Constructor of PayUIpn class
     * 
     * @param mixed $config Configuration array or filename
     * @param boolean $debug Debug mode
     */
    public function __construct($config, $debug=false){
        parent::__construct($config, $debug);
    }
    
    /*
     * Validate recceived data against HMAC HASH
     * 
     */
    public function validateReceived(){
		
		parent::logFunc("IPN",$_REQUEST,$_REQUEST['REFNOEXT']);
		
        if($this->createHashString($this->flatArray($_POST, array("HASH"))) == $_POST['HASH']){
            return true;
        } else {
            return false;
        }
    }
    
    /*
     * Creates INLINE string for corfirmation
     * 
     * @param boolean $echo Displays strings when true
     */
    public function confirmReceived($echo=false){
        $serverDate = date("YmdHis");
        $hashArray = array(
            $_POST['IPN_PID'][0],
            $_POST['IPN_PNAME'][0],
            $_POST['IPN_DATE'],
            $serverDate
        );
        $hash = $this->createHashString($hashArray);
		
		$string = "<EPAYMENT>".$serverDate."|".$hash."</EPAYMENT>";
			
        if($echo){
            echo $string;
        }

        return $string;
    }
}


/**
 * PayUIOS
 * 
 * Helper object containing information about a product
 *
 */
class PayUHungaryIosPMB extends PayUHungaryBasePMB{

     var $orderNumber;
	 var $hash;
	 var $merchantId;
	 var $orderStatus;
	 var $status = Array();
	
	public function __construct($config, $orderNumber = 0){
        parent::__construct($config, false);
		
		$hashArray = array(
            $this->merchantId,
            $orderNumber
        );
		$this->orderNumber = $orderNumber;
		$hash = $this->createHashString($hashArray);
		$this->hash = $hash;
		
		$this->runIos();
		
    }
	
	public function runIos(){
		
		$iosArray =array(
			'MERCHANT'=>$this->merchantId,
			'REFNOEXT'=>$this->orderNumber,
			'HASH'=>$this->hash
		);
		
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, 'https://secure.payu.hu/order/ios.php');
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($iosArray));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_USERAGENT, 'curl');
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);	
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_TIMEOUT, 600);
        $result = curl_exec($ch);
        curl_close($ch);
		
		$dom = new DOMDocument;
		$dom->loadXML($result);
		
		$order = $dom->getElementsByTagName("Order");
		foreach ($order->item(0)->childNodes as $item) {
			if ($item->nodeType == 1) {
				$this->status[$item->tagName] = $item->nodeValue;
			}
		}
		
	}
	
	/*
     * Getter method for ORDER_STATUS
     * 
     * @param string $orderNumber Order number in merchants system
     */
    public function getOrderStatus(){
        
        return $this->status["ORDER_STATUS"];
    }
	
	/*
     * Getter method for PAYMETHOD
     * 
     * @param string $orderNumber Order number in merchants system
     */
    public function getOrderPaymethod(){
        
        return $this->status["PAYMETHOD"];
    }
    
    /*
     * Getter method for ORDER_DATE
     * 
     * @param string $orderNumber Order number in merchants system
     */
    public function getOrderDate(){
       
        return $this->status["ORDER_DATE"];
    }

	/*
     * Getter method for REFNO
     * 
     * @param string $orderNumber Order number in merchants system
     */
    public function getOrderPayUNumber(){
       
        return $this->status["REFNO"];
    }
	
}


/**
 * PayUProduct
 * 
 * Helper object containing information about a product
 *
 */
class PayUHungaryProductPMB {
    public $name;
    public $group;
    public $code;
    public $info;
    public $price;
    public $qty;
    public $vat;
    public $ver;
    
    /*
     * Constructor for PayUProduct
     * 
     * Creates an object for a product for later processing
     * 
     * @param array $productParams Sets object properties according to variables passed in this array
     */
    public function __construct($productParams = array()){
        foreach ($productParams as $var=>$param){
            if (property_exists($this, $var)) {
                $this->$var = $param;
            }
        }
    }
}
?>